unit Testdemoclass;
{

  Delphi DUnit-Testfall
  ----------------------
  Diese Unit enthlt ein Skeleton einer Testfallklasse, das vom Experten fr Testflle erzeugt wurde.
  ndern Sie den erzeugten Code so, dass er die Methoden korrekt einrichtet und aus der
  getesteten Unit aufruft.

}

interface

uses
  TestFramework, democlass, Classes;

type
  // Testmethoden fr Klasse TDemoClass

  TestTDemoClass = class(TTestCase)
  strict private
    FDemoClass: TDemoClass;
  public
    procedure SetUp; override;
    procedure TearDown; override;
  published
    procedure TestAdd;
    procedure TestAddNegative;
    procedure TestGetData;
    procedure TestError;
  end;

implementation

procedure TestTDemoClass.SetUp;
begin
  FDemoClass := TDemoClass.Create(3, 5, 'IchBinText');
end;

procedure TestTDemoClass.TearDown;
begin
  FDemoClass.Free;
  FDemoClass := nil;
end;

procedure TestTDemoClass.TestAdd;
var
  ReturnValue: Integer;
  b: Integer;
  a: Integer;
begin
  a := 4;
  b := 8;
  ReturnValue := FDemoClass.Add(a, b);
  CheckEquals(12, ReturnValue);
end;

procedure TestTDemoClass.TestAddNegative;
var
  ReturnValue: Integer;
  b: Integer;
  a: Integer;
begin
  a := 4;
  b := -8;
  ReturnValue := FDemoClass.Add(a, b);
  CheckEquals(-4, ReturnValue);
end;

procedure TestTDemoClass.TestError;
begin
  StartExpectingException(EFileStreamError);
  FDemoClass.Error;
  StopExpectingException;
end;

procedure TestTDemoClass.TestGetData;
var
  ReturnValue: TTestrecord;
begin
  ReturnValue := FDemoClass.GetData;
  CheckEquals('IchBinText', ReturnValue.Text);
  CheckEquals(8, ReturnValue.Number);
end;

initialization
  // Alle Testflle beim Testprogramm registrieren
  RegisterTest(TestTDemoClass.Suite);
end.

